<script lang="ts">
  import TeamProposingForm from "./TeamProposingForm.svelte";
  import TeamVoteReveal from "./TeamVoteReveal.svelte";

  import {
    isAssassination,
    isGameComplete,
    isMissionInProgress,
    isMissionReveal,
    isRoleAssigning,
    isTeamProposing,
    isTeamVoteReveal,
    isTeamVoting,
  } from "./theResistance";

  export let state: GameState;
  export let user: PlayerState | undefined;
  $: phase = state.phase;

  $: assassinPlayer = state.players.find((p) => p.hand.Assassin);
</script>

<p class="phase-description">
  {#if isRoleAssigning(phase)}
    <em>Players are looking at their character cards.</em>
  {:else if isTeamProposing(phase)}
    <TeamProposingForm variant="above-board" {state} />
  {:else if isTeamVoting(phase)}
    <h3>Vote for mission {state.missions.length + 1} team</h3>
    <fieldset class="border mission-team">
      <legend>Team</legend>
      <ul>
        {#each phase.TeamVoting.team as playerId}
          <li><gs6-user userid={playerId} /></li>
        {/each}
      </ul>
    </fieldset>
  {:else if isTeamVoteReveal(phase)}
    <TeamVoteReveal variant="above-board" {state} {phase} {user} />
  {:else if isMissionInProgress(phase)}
    <h3>Mission {state.missions.length + 1} is in progress!</h3>
    <fieldset class="border mission-team">
      <legend>Team</legend>
      <ul>
        {#each Object.keys(phase.MissionInProgress.cards) as playerId}
          <li><gs6-user userid={playerId} /></li>
        {/each}
      </ul>
    </fieldset>
  {:else if isMissionReveal(phase)}
    <h3>Mission {state.missions.length + 1} is over!</h3>
    <fieldset class="border mission-team">
      <legend>Team</legend>
      <ul>
        {#each phase.MissionReveal.team as playerId}
          <li><gs6-user userid={playerId} /></li>
        {/each}
      </ul>
    </fieldset>
  {:else if isAssassination(phase) && assassinPlayer}
    <h3>The spies have one last chance to assassinate Merlin!</h3>
    <em>
      Spies may discuss freely. <gs6-user userid={assassinPlayer.id} /> must then
      choose a target to assassinate!
    </em>
  {:else if isGameComplete(phase)}
    <h2>
      {#if phase.GameComplete.winners === "Resistance"}
        The Resistance wins!
      {:else if phase.GameComplete.winners === "Spies"}
        The Spies win!
      {/if}
    </h2>
  {/if}
</p>

<style>
  .phase-description {
    text-align: center;
  }
  h2,
  h3 {
    font-weight: 500;
  }

  fieldset.mission-team {
    padding: 0.25em;
  }

  .mission-team > ul {
    margin: 0;
    display: flex;
    flex-direction: row;
    flex-wrap: wrap-reverse;
    justify-content: center;
  }
  .mission-team > ul > li {
    margin-left: 0.5em;
    margin-right: 0.5em;
    margin-bottom: 0.25em;
  }
</style>
